#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2one4search.py">
#<abstract4xi abstract = "shoots to direction one"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2one4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2one4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2one4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4one

global count2ack4one
global count2nack4one
global count2found4one
global count2short4one

global current2series4one
global candidate2series4one

global fileobject4one  

global keys2profile4one
global key2profile4one

global left2find4one

global maxsize2ack4one    
global maxsize2file4one 
global max2short4one
global meansize2ack4one
global minsize2ack4one

global one2analyse4search

global profile2fetch4one

global right2find4one

global sumsize2ack4one    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4one = VersionKB4Xi['base2shoot4one']             # base internet address, None=local url

count2ack4one   = 0
count2nack4one  = 0
count2found4one = 0
count2short4one = 0

left2find4one = '('

max2short4one = VersionKB4Xi['max2short4one']
maxsize2file4one = VersionKB4Xi['maxsize2file4one']
maxsize2ack4one  = 0
meansize2ack4one = 0
minsize2ack4one  = 0

current2series4one = "current2series4one5dummy"
candidate2series4one  = "candidate2series4one5dummy"


one2analyse4search  = VersionKB4Xi['one2analyse4search']

profile2fetch4one = {}
profile2fetch4one [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4one [2] = '.jpg'
keys2profile4one = profile2fetch4one.keys()

right2find4one = ')'

sumsize2ack4one  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4one" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4one(target2explore4one):
    global count2ack4one
    global count2nack4one
    global count2found4one
    global count2short4one
    
    global fileobject4one 
       
    global keys2profile4one
    global key2profile4one
    
    global left2find4one

    global max2short4one    
    global maxsize2file4one     
    global maxsize2ack4one    
    global meansize2ack4one
    global minsize2ack4one
  
    global candidate2series4one
    global current2series4one
    
    
    global profile2fetch4one                         # extension for files
    
    global right2find4one
    
    global sumsize2ack4one    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4one = count2found4one + 1
    ack2debug4one = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4one)
    
    ack2profile = False
    for key2profile4one in keys2profile4one:
        if name2target[1] == profile2fetch4one[key2profile4one]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2ONE4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4one
        if ack2debug4one is True:
            print("(STEP 0A/33) OF SHOOT2ONE4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2ONE4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4one:
            count2nack4one = count2nack4one + 1
        else:
            count2ack4one = count2ack4one + 1
            sumsize2ack4one = sumsize2ack4one + size2file
            if size2file > maxsize2ack4one:
                maxsize2ack4one = size2file
            if ((size2file < minsize2ack4one) or (minsize2ack4one == 0)):
                print("(STEP 0B/33) OF SHOOT2ONE4SEARCH - USING MINSIZE2ACK4ONE: ", minsize2ack4one, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4ONE:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2one//d\onefly29july2012\onefly29july2012 (1).JPG 
                # USING MINSIZE2ACK4ONE:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2one//d\onefly29july2012\onefly29july2012 (2).JPG
                minsize2ack4one = size2file
                print("(STEP 0C/33) OF SHOOT2ONE4SEARCH - SET MINSIZE2ACK4ONE TO: ", minsize2ack4one, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4ONE TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2one//d\onefly29july2012\onefly29july2012 (1).JPG
                # SET MINSIZE2ACK4ONE TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2one//d\onefly29july2012\onefly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4one = target2explore4one
            if ack2debug4one is True:print("(STEP 1A/33) OF SHOOT2ONE4SEARCH - URL2WEB4ONE: ", url2web4one) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4one,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4one = url2web4one[0:index2edit] + string2use + url2web4one[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4one)
            shortname2web4one = name2web[0]
            if ack2debug4one is True:
                print("(STEP 1B/33) OF SHOOT2ONE4SEARCH - SHORTNAME2WEB4ONE: ", shortname2web4one)
                # 
            
            string2find4one = '/'
            ackall2found4one = False           
            while 1:
                if ackall2found4one is True:
                    break
                else:
                    index2find4one=str.find(shortname2web4one,string2find4one)   
                    if index2find4one == -1:
                        ackall2found4one = True
                    else:
                        shortname2web4one = shortname2web4one[index2find4one+1:]
                        
            if ack2debug4one is True:            
                print("(STEP 1C/33) OF SHOOT2ONE4SEARCH - SHORTNAME2WEB4ONE: ", shortname2web4one)
                # 
                
            ackall2found4one = False 
            while 1:
                if ackall2found4one is True:
                    break
                else:
                    index2left4one=str.find(shortname2web4one,left2find4one)
                    if index2left4one == -1:
                        current2series4one = shortname2web4one
                        if ack2debug4one is True:
                            print("(STEP 2A/33) OF SHOOT2ONE4SEARCH - CURRENT2SERIES4ONE: ", current2series4one) 
                            # 
                        ackall2found4one = True
                         
                    else:
                        index2right4one=str.find(shortname2web4one,right2find4one)
                        if index2right4one == -1:
                            ackall2found4one = True 
                        else:
                            candidate2series4one = shortname2web4one[0:index2left4one]
                            
                            index3find4one=str.find(shortname2web4one,current2series4one)
                            if index3find4one == -1:
                                
                                current2series4one = candidate2series4one
                                if ack2debug4one is True:
                                    print("(STEP 2B/33) OF SHOOT2ONE4SEARCH - CURRENT2SERIES4ONE: ", current2series4one) 
                                    # 
                                
                                count2short4one = 0
                                fileobject4one.write('<br />' + '\n')
                            else:
                                shortname2web4one = shortname2web4one[index2left4one:index2right4one+1]
                                if ack2debug4one is True:
                                    print("(STEP 2C/33) OF SHOOT2ONE4SEARCH - SHORTNAME2WEB4ONE: ", shortname2web4one)
                                    # 
                                
                                count2short4one = count2short4one + 1
                                if count2short4one >= max2short4one:
                                    count2short4one = 0
                                else:
                                    pass       
                            ackall2found4one = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4one is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4one.write('<br /><b>&raquo;</b><a href="' + url2web4one + '" target="_blank">' + shortname2web4one + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4one = one2analyse4search
                if ack2debug4one is True:
                    print("(STEP 3A/33) OF SHOOT2ONE4SEARCH - BASE2LOCAL4ONE: ", base2local4one)
                    #              
                ack2localtries4one = False                   
                while 1:
                    if ack2localtries4one is True:
                        break
                    else:
                        index2find4one=str.find(url2web4one,base2local4one)            
                        # 
                        #  
                        if index2find4one == -1:
                            ack2localtries4one = True
                        else:
                            if ack2debug4one is True:
                                print("(STEP 3B/33) OF SHOOT2ONE4SEARCH - BASE2BUILD4ONE: ", base2build4one)
                                # 
                            url2web4one = base2build4one + url2web4one[len(base2local4one):]
                            if ack2debug4one is True:
                                print("(STEP 3C/33) OF SHOOT2ONE4SEARCH - URL2WEB4ONE: ", url2web4one)
                                # 
                            
                            if count2short4one < 1: 
                                fileobject4one.write('<br /><b>&raquo;</b><a href="' + url2web4one + '" target="_blank">' + shortname2web4one + '</a>' + '\n')
                            else:
                                fileobject4one.write('<b>&raquo;</b><a href="' + url2web4one + '" target="_blank">' + shortname2web4one + '</a>\n')                            
                            ack2localtries4one = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2ONE4SEARCH FAILED, FILEOBJECT4ONE-WRITE-FAILED: ", str(fileobject4one), time4xi())
      
    else:
        
        count2nack4one = count2nack4one + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2one4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2one4search(queue2one = None, consumer_channel2one = None, publisher_channel2one = None, path2one = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4one
    global count2nack4one
    global count2found4one
    
    global fileobject4one    
    
    global maxsize2ack4one    
    global meansize2ack4one
    global minsize2ack4one
    global sumsize2ack4one    
    
    global maxsize2file4one 
    
    global profile2fetch4one                         # extension for files
    global keys2profile4one
    global key2profile4one

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2ONE4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2ONE4SEARCH -  QUEUE2ONE: ", queue2one)      
    # QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2ONE4SEARCH -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
    # CONSUMER_CHANNEL2ONE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2ONE4SEARCH -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
    # PUBLISHER_CHANNEL2ONE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2one is None) or (consumer_channel2one is None) or (publisher_channel2one is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2ONE4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2ONE4SEARCH - QUEUE2ONE: ", queue2one)
        print("(STEP 1C/33) OF SHOOT2ONE4SEARCH - CONSUMER_CHANNEL2ONE: ", consumer_channel2one) 
        print("(STEP 1D/33) OF SHOOT2ONE4SEARCH - PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)
        print("(STEP 1E/33) OF SHOOT2ONE4SEARCH - PATH2ONE: ", path2one)     
        
        return
 
    if (not (queue2one is None) and not(consumer_channel2one is None) and not(publisher_channel2one is None) and (path2one is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2ONE4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2ONE4SEARCH - QUEUE2ONE: ", queue2one)
        print("(STEP 2C/33) OF SHOOT2ONE4SEARCH - CONSUMER_CHANNEL2ONE: ", consumer_channel2one) 
        print("(STEP 2D/33) OF SHOOT2ONE4SEARCH - PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)
        print("(STEP 2E/33) OF SHOOT2ONE4SEARCH - PATH2ONE: ", path2one)     
        return           

    if (not (queue2one is None) and not(consumer_channel2one is None) and not(publisher_channel2one is None) and not(path2one is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2ONE4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2ONE4SEARCH - QUEUE2ONE: ", queue2one)
        # QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2ONE4SEARCH - CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # CONSUMER_CHANNEL2ONE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2ONE4SEARCH - PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)
        # PUBLISHER_CHANNEL2ONE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2ONE4SEARCH - PATH2ONE: ", path2one)
        # PATH2ONE:  F://temp//yophotos//test2one//
       
        print("(STEP 4A/33) OF SHOOT2ONE4SEARCH - STARTING TO WALK PATH2ONE: ", path2one)   
        # STARTING TO WALK PATH2ONE:  F://temp//yophotos//test2one//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4one = None
        try:
            name2index4one = "index2xxxxxxxx4yo.html"
            path2index4one = path2one + name2index4one
            print("(Step 4B/33) OF SHOOT2ONE4SEARCH - SET PATH2INDEX4ONE TO: ", path2index4one)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2ONE4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4ONE: ", path2index4one)          
            #                    
        fileobject4one = None
        try:
            fileobject4one = open(path2index4one,'w')
            print("(Step 4C/33) OF SHOOT2ONE4SEARCH - OPENED OUTPUT: ", fileobject4one)
            # SHOOT2ONE4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2one//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2ONE4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4one)         
            # 
        try:                
            fileobject4one.write('<html>\n')
            
            fileobject4one.write('<style type="text/css" media="all">\n')
            fileobject4one.write(' @import "http://www.youronexi.org/css/halongbay.css";\n')
            fileobject4one.write('</style> \n')
            fileobject4one.write('<p>\n')
            fileobject4one.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4one.write('<br /><a id="000">yourone<b>&Xi;</b> @Content</a>\n')
            fileobject4one.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4one.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2ONE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4one)         
            #      
        
        
        KB2name4one = {}
        key2name4one = 0
                 
        for file2walk in DirectoryWalker(path2one):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4one [key2name4one] = file2walk
                    print ("KB2NAME4ONE[", key2name4one, "]: ", KB2name4one [key2name4one])
                    # 
                    
                    key2name4one = key2name4one + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2ONE4SEARCH - FAILED UPDATING KB2NAME4ONE WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4one(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4one.write('<br /> \n')
            fileobject4one.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4one.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4one.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4one.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4one.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4one.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4one.write('</p>\n')
            # 
            fileobject4one.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2ONE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4one)         
            #            
        try:    
            fileobject4one.close()
            print("(Step 4C/33) OF SHOOT2ONE4SEARCH - CLOSED OUTPUT: ", fileobject4one)         
            # SHOOT2ONE4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2one//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2ONE4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4one)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2ONE4SEARCH - STARTING TO ANALYSE KB2NAME4ONE: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4ONE:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4one  = {}
        AlphaKB4one['a'] = {}
        AlphaKB4one['b'] = {}
        AlphaKB4one['c'] = {}
        AlphaKB4one['d'] = {}
        AlphaKB4one['e'] = {}
        AlphaKB4one['f'] = {}
        AlphaKB4one['g'] = {}
        AlphaKB4one['h'] = {}
        AlphaKB4one['i'] = {}
        AlphaKB4one['j'] = {}
        AlphaKB4one['k'] = {}
        AlphaKB4one['l'] = {}
        AlphaKB4one['m'] = {}
        AlphaKB4one['n'] = {}
        AlphaKB4one['o'] = {}
        AlphaKB4one['p'] = {}
        AlphaKB4one['q'] = {}
        AlphaKB4one['r'] = {}
        AlphaKB4one['s'] = {}
        AlphaKB4one['t'] = {}
        AlphaKB4one['u'] = {}
        AlphaKB4one['v'] = {}
        AlphaKB4one['w'] = {}
        AlphaKB4one['x'] = {}
        AlphaKB4one['y'] = {}
        AlphaKB4one['z'] = {} 
        keys2AlphaKB4one = AlphaKB4one.keys()
        key2AlphaKB4one  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4one = len(path2one)
        # 
        
        keys2name4one = KB2name4one.keys()
                
        for key2name4one in sorted(keys2name4one):
            # 
            name2optimize4one = KB2name4one[key2name4one]
            # 
            shortcut2level4one = name2optimize4one[len2cut4one:]
            # 
            len2shortcut4one = len(shortcut2level4one)
            if len2shortcut4one == 1:
                try:
                    # LEVEL ONE CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4one in keys2AlphaKB4one:
                        KB2level1[key2level1] = shortcut2level4one
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2ONE4SEARCH ** WARNING - SHORTCUT2LEVEL4ONE: ", shortcut2level4one, " NOT IN KEYS2ALPHAKB4ONE: ", keys2AlphaKB4one)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2ONE4SEARCH *** FAILED - SHORTCUT2LEVEL4ONE: ", shortcut2level4one)      
            else:
                try:
                    
                    string2search4one = '\\'
                    shortcut2level4one = shortcut2level4one[2:]
                    
                    index2level4one=str.find(shortcut2level4one,string2search4one)
                    if index2level4one == -1:
                         
                        KB2level2[key2level2] = shortcut2level4one
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4one = shortcut2level4one[index2level4one+1:]
                        index2level4one=str.find(shortcut2level4one,string2search4one)
                        if index2level4one == -1:
                            KB2level3[key2level3] = shortcut2level4one
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4one = shortcut2level4one[index2level4one+1:]
                            index2level4one=str.find(shortcut2level4one,string2search4one)
                            if index2level4one == -1:
                                KB2level4[key2level4] = shortcut2level4one
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4one = shortcut2level4one[index2level4one+1:]
                                index2level4one=str.find(shortcut2level4one,string2search4one)
                                if index2level4one == -1:
                                    KB2level5[key2level5] = shortcut2level4one
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4one = shortcut2level4one[index2level4one+1:]
                                    index2level4one=str.find(shortcut2level4one,string2search4one)
                                    if index2level4one == -1:
                                        KB2level6[key2level6] = shortcut2level4one
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4one = shortcut2level4one[index2level4one+1:]
                                        index2level4one=str.find(shortcut2level4one,string2search4one)
                                        if index2level4one == -1:
                                            KB2level7[key2level7] = shortcut2level4one
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4one = shortcut2level4one[index2level4one+1:]
                                            index2level4one=str.find(shortcut2level4one,string2search4one)
                                            if index2level4one == -1:
                                                KB2level8[key2level8] = shortcut2level4one
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2ONE4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4ONE: ", shortcut2level4one)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2ONE4SEARCH *** FAILED - SHORTCUT2LEVEL4ONE: ", shortcut2level4one)   
        
        print ("(Step 6A/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # onefly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2ONE4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2ONE4SEARCH - COUNT2ACK4ONE; ", count2ack4one)
            # COUNT2ACK4ONE;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2ONE4SEARCH - COUNT2NACK4ONE; ", count2nack4one)
            # COUNT2NACK4ONE;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2ONE4SEARCH - COUNT2FOUND4ONE: ", count2found4one)
            # COUNT2FOUND4ONE:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2ONE4SEARCH - FOUND MAX SIZE: ", maxsize2ack4one)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2ONE4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4one)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4one == 0:
                meansize2ack4one = 0
                print ("(Step 7G1/33) OF SHOOT2ONE4SEARCH - MEAN SIZE SET: ", meansize2ack4one)
                #  
            else:       
                meansize2ack4one = int(sumsize2ack4one / count2ack4one)
                print ("(Step 7G2/33) OF SHOOT2ONE4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4one, ", WHERE SUMSIZE2ACK4ONE: ", sumsize2ack4one, " COUNT2ACK4ONE: ", count2ack4one)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4ONE:  10944512  COUNT2ACK4ONE:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2ONE4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4one < maxsize2file4one:
                print ("(Step 7H/33) OF SHOOT2ONE4SEARCH - MIN SIZE MET: ", minsize2ack4one)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2ONE4SEARCH ** MIN DEFINED: ", minsize2ack4one, " EQUALS TO MAXSIZE2FILE4ONE: ", maxsize2file4one)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2ONE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2ONE4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2ONE4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2ONE4SEARCH - QUEUE2ONE: ", queue2one)
        print("(STEP 7Z3/33) OF SHOOT2ONE4SEARCH - CONSUMER_CHANNEL2ONE: ", consumer_channel2one) 
        print("(STEP 7Z4/33) OF SHOOT2ONE4SEARCH - PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)
        print("(STEP 7Z5/33) OF SHOOT2ONE4SEARCH - PATH2ONE: ", path2one)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.onexi.com; www.youronexi.com; www.youronexi.org; www.one2xi.com/; www.one4xi.com/; www.one8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2one4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
